/**
 * core.js - all global scripts belong in this file.
 */

// NAMESPACE FOR COMMON FUNCTIONS/OBJECTS
var COMMONUTILS = {
    //
    pageWidth : function () {"use strict";
        return document.documentElement.clientWidth;
    },

    // OBJ TO HOLD USERS CURRENT WEBPAGE LOCATION
    currentPage : window.location.pathname.substring (window.location.pathname.lastIndexOf ('/') + 1),

    // FUNCTION TO EXECUTE CODE BASED ON LOCATION
    userLocation : function (pagename) {"use strict";
        var page = pagename;
        $ ('#nav a').removeClass ('active');
        switch(page) {
            case 'index':
                $ ('#nav-home').addClass ('active');
                break;
            case 'about':
                $ ('#nav-about').addClass ('active');
                break;
            case 'cast':
                $ ('#nav-cast').addClass ('active');
                break;
            case 'news':
                $ ('#nav-news').addClass ('active');
                break;
            case 'reviews':
                $ ('#nav-reviews').addClass ('active');
                break;
            case 'tickets':
                $ ('#nav-tickets').addClass ('active');
                break;
            case 'gallery':
                $ ('#nav-gallery').addClass ('active');
                break;
            case 'privacy':
                $ ('#nav a').removeClass ('active');
                break;
            default:
                // No Case
                $ ('#nav-home').addClass ('active');
        }
    },

    optinFormValidate: function() {
    	"use strict";

      var formName = "";

      $(".subscribe").each(function(i){

      	//console.log(i);
      	formName = "optin"+i;
      	$(this).attr("id",formName);

          //
          $(this).validate({
            rules : {
              email : { required : true, email : true }/*,
              zip : 'required'*/
            },
            messages : {
              email : 'Enter a valid email'/*,
              zip : 'Enter your zip code'*/
            },
            errorPlacement : function(error, element) {
              element.attr('placeholder', error[0].outerText);
            },
            submitHandler : function(form) {
              $.ajax({
                url : './_inc/optin_action.php',
                type : 'POST',
                data : $(form).serialize() + '&ajax=true',
                success : function() {
                  $(form).hide();
                  $(form).parent("div").append('<h3 class="text-center form-thanks">THANK YOU FOR SIGNING UP.<span>Check your email to confirm your subscription.</span></h3>');
                  dataLayer.push({'event': 'signup-successful'});
                }
              });
              return false;
            }
          });

      });
    },

    nav: function() {
    	"use strict";

    	$("#btn-menu").on("click",function(e){
      	e.preventDefault();
      	if( $("#nav").hasClass("open") ){
        	$("#nav, #btn-menu").removeClass("open");
        	$("#btn-menu").removeClass("fa-times-thin").addClass("fa-bars");
      	} else {
        	$("#nav, #btn-menu").addClass("open");
        	$("#btn-menu").addClass("fa-times-thin").removeClass("fa-bars");
      	}
    	});

    }
};

// jQuery Namespace
$ (document).ready (function () {"use strict";
    COMMONUTILS.optinFormValidate();

    /* IMAGE ROTATION */
    $("#characters > div:gt(0)").hide();
    setInterval(function() {
      $('#characters > div:first')
        .fadeOut(1000)
        .next()
        .fadeIn(1000)
        .end()
        .appendTo('#characters');
      }, 3000);

      function heightFix() {
        var slideHeight = $('#characters img').height();
        $('#characters').height(slideHeight);
      }

      heightFix();

      $(window).resize(function() {
          "use strict";
          heightFix();
      });

      //$("#popup").show();
      //$("#popup-bg").show();


      //cookie user for popup
      /*function setCookie(cookieName,cookieValue,nDays) {
       var today = new Date();
       var expire = new Date();
       if (nDays==null || nDays==0) nDays=1;
       expire.setTime(today.getTime() + 3600000*24*nDays);
       document.cookie = cookieName+"="+escape(cookieValue) + ";expires="+expire.toGMTString();
      }

      function getCookie(cookieName) {
         var theCookie=" "+document.cookie;
         var ind=theCookie.indexOf(" "+cookieName+"=");
         if (ind==-1) ind=theCookie.indexOf(";"+cookieName+"=");
         if (ind==-1 || cookieName=="") return "";
         var ind1=theCookie.indexOf(";",ind+1);
         if (ind1==-1) ind1=theCookie.length;
         return unescape(theCookie.substring(ind+cookieName.length+2,ind1));
      }

      $(function() {
           var skipModal = getCookie('skipModal');
           console.log(skipModal);
           if (!skipModal) {
               $("#popup").show();
               $("#popup-bg").show();
               setCookie('skipModal', 'true', 365*5);
           }
      });*/


      $(document).on( "click",".close-popup", function(e) {
        e.preventDefault();
        $("#popup").fadeOut();
        $("#popup-bg").fadeOut();
      });

      $(document).on( "click","#popup-bg", function(e) {
        e.preventDefault();
        $("#popup").fadeOut();
        $("#popup-bg").fadeOut();
      });


      //QUOTES
      $('.quote-block').slick({
        slidesToShow: 1,
        slidesToScroll: 1,
        arrows:false,
        autoplay:true,
        autoplaySpeed:4000,
        fade:true
      });

    $(".rev-img").mouseover(function() {
        var src = $(this).attr("src").replace(".png", "-hover.png");
        $(this).attr("src", src);
    })
    .mouseout(function() {
        var src = $(this).attr("src").replace("-hover.png", ".png");
        $(this).attr("src", src);
    });

});

// EOF
