var MobileSchedule = {

    // JSON results for show dates and times will be stored here
    Times : null,
    Avail : null,

    // Get JSON file, call appropriate parsing function after
    Fetch : function (source, callback) {
        $.getJSON (source, function (data) {
            // Format dates if Ticketmaster calendar

            //console.log(data.contents);
            if (data.contents) {
                Schedule.Times = data.contents;
                for (key in Schedule.Times) {
                    var date = (Schedule.Times [key].event_SEO_name.slice (-10)).split ("-");
                    Schedule.Times [key].date = date [2] + '-' + date [0] + '-' + date [1];
                }
            } else {
                Schedule.Times = data;
            }
            callback ();
        });
    },

    PopulateMobile : function (container, eventslist) {
      var months = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];

      //console.log(eventslist);

      for (var i = 0; i < eventslist.length; i++) {
        var eventMonth = eventslist[i].showMonth;
        var eventDoW = eventslist[i].showDoW;
        var eventTime = eventslist[i].showTime;
        var eventDate = eventslist[i].showDate;
        var eventYear = eventslist[i].showYear;
        var monthName = months[eventMonth - 1];
        var eventLink = eventslist[i].url;
        var monClass = "." + monthName.toLowerCase();
        var combined = eventDoW + " " + monthName + " " + eventDate + ", " + eventYear + " at " + eventTime;

        var eventInfo = "<option value='" + eventLink + "'><span>" + eventDoW + " </span><span>" + eventDate + " </span><span>" + eventTime + " </span></option>";
        $(monClass).append(eventInfo);

        if (eventDate === '01') {
          var firstShow = "<span class='fom-date " + monthName + "'>" + eventDoW + " " + eventDate + " " + eventTime + "</span><span class='fom-link " + monthName + "'>" + eventLink + "</span>";
          if (monthName === "Oct" && eventTime === "8:00pm") {

          } else {
            $('#monthStart').append(firstShow);
          }
        }

        if (monthName === "Aug" && eventDate === '02') {
          var firstShow = "<span class='fom-date " + monthName + "'>" + eventDoW + " " + eventDate + " " + eventTime + "</span><span class='fom-link " + monthName + "'>" + eventLink + "</span>";
          $('#monthStart').append(firstShow);
        }

        if (i == 0) {
          var firstOverallShow = "<span class='fom-date " + monthName + "'>" + eventDoW + " " + eventDate + " " + eventTime + "</span><span class='fom-link " + monthName + "'>" + eventLink + "</span>";
          $('#monthStart').append(firstOverallShow);
        }
      }
    },

    // SeatGeek LINK FORMATTING
    // Call this for calendars with direct performance ticket links
    Telecharge : function (container, telecode) {
        function getDayOfWeek(date) {
          const dayOfWeek = new Date(date).getDay();
          return isNaN(dayOfWeek) ? null :
            ['Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday', 'Sunday'][dayOfWeek];
        }

        function convertTime12to24(time12h) {
          const [time, modifier] = time12h.split(' ');
          let [hours, minutes] = time.split(':');

          if (hours === '12') {
            hours = '00';
          }

          if (modifier === 'PM') {
            hours = parseInt(hours, 10) + 12;
          }

          return hours + ":" + minutes + ":00";
         }

        var eventslist = [];

        //Date fix
        var calDate = new Date();
        calDate.setDate(calDate.getDate() - 1);

        // Format events for calendar
        for (var i = 0; i < Schedule.Times.length; i++) {

          var monthList = ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"];


            var dateformatted = (Schedule.Times [i].date).split ("-");
            dateformatted = dateformatted [1] + '/' + dateformatted [2] + '/' + dateformatted [0];

            var date = Schedule.Times [i].date;
            var time = Schedule.Times [i].showtime;
            var timeFull = convertTime12to24(time);

            var fullDate = date + "T" + timeFull;

            var year = fullDate.substring(0,4);
            var month = fullDate.substr(5,2);
            var day = fullDate.substr(8,2);
            var monthName = monthList[month - 1];

            var linktime = fullDate.substr(11,5);
            var splitTime = linktime.split(':');
            var showtime = (splitTime[0] - 12) + ':' + splitTime[1] + "pm";

            var fullDateName = monthName + " " + day + ", " + year + " " + timeFull;
            var dateDOW = new Date(fullDateName);
            var shortDoW =  dateDOW.toLocaleDateString('en-US', { weekday: 'short',});

            /* var showDate = year + "-" + month + "-" + day;
             var showDayOfWeek = getDayOfWeek(showDate);
             var shortDoW = showDayOfWeek.substring(0,3);*/

             var showType;
             if( showtime === "2:00" || showtime === "3:00" ){
               showType = 'mat';
             } else {
               showType = 'eve';
             }


            if (calDate <= new Date (Schedule.Times [i].date)) {
                eventslist.push ({
                    url : 'http://www.telecharge.com/Broadway/' + telecode + '/Ticket?&PerformanceDateTime=' + dateformatted + '%20' + Schedule.Times [i].showtime,
                    showDoW: shortDoW,
                    showDate: day,
                    showMonth: month,
                    showYear: year,
                    showTime: showtime
                });
            }
        }

        //console.log(eventslist);
        MobileSchedule.PopulateMobile (container, eventslist);

    },

};

// jQuery Namespace
$ (document).ready (function () {"use strict";

  // Mobiscroll Select initialization
  function scrollInit() {
    $('#mobile-cal').mobiscroll().select({
        display: 'inline',
        showInput: false,
        group: {
          groupWheel: true,
          header: false,
          clustered: true
        },
        onInit: function(event, inst) {
          var link = $(this).val();
          var showInfo = inst._value;

          var monFind = $("body").find("[aria-selected='true']");
          var selShowMon = monFind[0].innerHTML;
          var selShowDayWeek = showInfo.slice(0,3);
          var selShowDate = showInfo.slice(4,7);
          var selShowTime = showInfo.slice(7,14);

          var selPerf =  selShowDayWeek + " " + selShowMon + " " + selShowDate + " at " + selShowTime;
          $('.perf').html("<a href='" + link + "' target='_blank' class='mobile-date'>" + selPerf + "</a>");
          $('.tix-button').html("<a href='" + link + "' target='_blank' class='mobile-tix'>GET TICKETS</a>");
        },
        onChange: function (event, inst) {
          var lastMon = $('#curMon').text();
          var link = $(this).val();
          var showInfo = inst._value;
          var monFind = $("body").find("[aria-selected='true']");
          var selShowMon = monFind[0].innerHTML;
          var selShowDayWeek;
          var selShowDate;
          var selShowTime;
          if ( selShowMon === lastMon ){
            selShowDayWeek = showInfo.slice(0,3);
            selShowDate = showInfo.slice(4,7);
            selShowTime = showInfo.slice(7,14);
            //console.log('same month');
          } else {
            var firstMonClass = "." + selShowMon + ".fom-date";
            var firstMonLink = "." + selShowMon + ".fom-link";
            var firstMonShow = $(firstMonClass).text();
            var firstMonURL = $(firstMonLink).text();
            selShowDayWeek = firstMonShow.slice(0,3);
            selShowDate = firstMonShow.slice(4,7);
            selShowTime = firstMonShow.slice(7,14);
            link = firstMonURL;
            //console.log('new month');
          }
          var selPerf =  selShowDayWeek + " " + selShowMon + " " + selShowDate + " at " + selShowTime;

          var curMon = selShowMon;
          $('#curMon').html(curMon);
          $('.perf').html("<a href='" + link + "' target='_blank' class='mobile-date'>" + selPerf + "</a>");
          $('.tix-button').html("<a href='" + link + "' target='_blank' class='mobile-tix'>GET TICKETS</a>");
        }
    });
  }

  MobileSchedule.Fetch();
  setTimeout(function(){
    MobileSchedule.Telecharge("#mobile-cal", "POTUS-Or-Behind-Every-Great-Dumbass-Are-Seven-Women-Trying-to-Keep-Him-Alive");
  }, 2000);
  setTimeout(scrollInit, 2100);


  function perfSelect() {
    $('select').on('change', function() {
      var selected = $(this).text();
      var link = $(this).val();
      //$('.perf').html("<a href='" + link + "' target='_blank'>" + selected + "</a>");
    });
  }

  setTimeout(perfSelect, 2200);

});
