//Namespace for bio functions
var bioGrid = {};

bioGrid.bioindex = 0;
bioGrid.bios = [];

bioGrid.loadBios = function (divID, page) {"use strict";
    //Cast & Creative Bios
    $(divID).load(page, null, function () {
        //
        if (divID === "#cast-bios") {
            var thumbs = "";
            for (var i=1; i <= $("#cast-bios .team-member").length; i++) {
                thumbs += '<a class="cast-member actor-' + i + '" href="#' + (i - 1) + '" ><div class="cast-image">' + $('#cast-bios .team-member:nth-child(' + i + ') .castpic').html() + '</div><div class="cast-name">' + $('#cast-bios .team-member:nth-child(' + i + ') h3 strong').html() + '</div><div class="cast-role">' + $('#cast-bios .team-member:nth-child(' + i + ') h3 em').html() + '</div></a>';
                bioGrid.bios.push($('#cast-bios .team-member:nth-child('+i+')').html());
            }

            bioGrid.loadBios('#creative-bios','creative.html');

        } else if (divID === "#creative-bios") {
            var thumbs = "";
            for (var j=1; j <= $("#creative-bios .team-member").length; j++) {
            thumbs += '<a class="cast-member actor-' + bioGrid.bios.length + '" href="#' + bioGrid.bios.length + '" ><div class="cast-name">' + $('#creative-bios .team-member:nth-child(' + j + ') h3 strong').html() + '</div><div class="cast-role">' + $('#creative-bios .team-member:nth-child(' + j + ') h3 em').html() + '</div></a>';
            bioGrid.bios.push($('#creative-bios .team-member:nth-child('+ j +')').html());
          }

        }

        $(divID).html(thumbs);
        setTimeout(() => { $('body').addClass('bio-loaded'); }, 1000);


        $(divID + " .cast-member").click( function(e) {
            e.preventDefault();
            bioGrid.bioindex = Number($(this).attr("href").split("#")[1]);

            //add overlay
            $("#overlay-inner").html("").html("<div>" + bioGrid.bios [ ($(this).attr("href").split("#") [1]) ] + "</div>");
            $("html, body").addClass ("overlay-open");
            $(".overlay").addClass ("open");


            //next/prev
            $(".overlay-prev, .overlay-next").show();
            if (bioGrid.bioindex == (bioGrid.bios.length - 1)) {
                $(".overlay-next").hide();
            } else if (bioGrid.bioindex == 0) {
                $(".overlay-prev").hide();
            }

            //scroll, if necessary
            if ( $('.overlay .container').height() > $(window).height() ) {
                var slideheight = $(window).height () - $(".overlay-close").height()*2 - 100;
                $('#overlay-inner > div').slimscroll ({
                    height : slideheight + 'px', alwaysVisible : true, color : '#2dc2cd', railVisible : true, railColor : '#000'
                });
            }
        });
    })
};

//Next/Previous navigation
bioGrid.bioNav = function () {
    $(".overlay-next").click(function(e) {
        e.preventDefault();
        $(".overlay-prev").show();
        if (bioGrid.bioindex == (bioGrid.bios.length - 2)) {
            $(this).hide();
        }
        else { $(this).show(); }
        bioGrid.bioindex = bioGrid.bioindex + 1;
        $("#overlay-inner").fadeOut(300, function() {
            $(this).html(bioGrid.bios[bioGrid.bioindex]).fadeIn(500);
        });
    });

    $(".overlay-prev").click(function(e) {
        e.preventDefault();
        $(".overlay-next").show();
        if (bioGrid.bioindex == 1) {
            $(this).hide();
        }
        else { $(this).show(); }
        bioGrid.bioindex = bioGrid.bioindex - 1;
        $("#overlay-inner").fadeOut(300, function() {
            $(this).html(bioGrid.bios[bioGrid.bioindex]).fadeIn(500);
        });
    });
};

// Close Cast Overlay
bioGrid.hideOverlay = function () {
    $ (".overlay-close").click (function (e) {
        e.preventDefault ();
        $ ("html, body").removeClass ("overlay-open");
        $ (".overlay").removeClass ("open");
    });
};


$(document).ready (function () {"use strict";
    bioGrid.loadBios('#cast-bios','cast.html');
    bioGrid.bioNav();
    bioGrid.hideOverlay();

    if (window.location.hash === '#creative') {
      $(this).addClass('active');
      $('#cast-block').hide();
      $('.cast-link').removeClass('active');
      $('.creative-link').addClass('active');
      $('#creative-block').fadeIn();
      $('#creative-block').css({
        'opacity':'1',
        'height':'auto',
        'visibility':'visible'
      });
      $('#creative').addClass('creative-bump');
    }

    //cast toggle
    $(document).on( "click",".creative-link", function(e) {
      e.preventDefault();
      if($(this).hasClass('active')) {
        $('#creative-block').fadeOut();
        $(this).removeClass('active');
        $(this).children('.plus').text('+');
      } else {
        $(this).addClass('active');
        $('.plus').text('+');
        $(this).children('.plus').text('-');
        $('#cast-block').hide();
        $('.cast-link').removeClass('active');
        $('#creative-block').fadeIn();
        $('#creative-block').css({
          'opacity':'1',
          'height':'auto',
          'visibility':'visible'
        });
        $('#creative').addClass('creative-bump');
      }
    });

    $(document).on( "click", ".cast-link", function(e) {
      e.preventDefault();
      if($(this).hasClass('active')) {
        $('#cast-block').fadeOut();
        $(this).removeClass('active');
        $(this).children('.plus').text('+');
      } else {
        $(this).addClass('active');
        $('.plus').text('+');
        $(this).children('.plus').text('-');
        $('.creative-link').removeClass('active');
        $('#creative-block').hide();
        $('#cast-block').fadeIn();
        $('#creative').removeClass('creative-bump');
      }
    });



});

// EOF
